"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
from clerk_dev.types import BaseModel
from enum import Enum
from typing import Optional, TypedDict
from typing_extensions import NotRequired


class IdentifierType(str, Enum):
    EMAIL_ADDRESS = "email_address"
    PHONE_NUMBER = "phone_number"
    WEB3_WALLET = "web3_wallet"


class AllowlistIdentifierObject(str, Enum):
    r"""String representing the object's type. Objects of the same type share the same value.

    """
    ALLOWLIST_IDENTIFIER = "allowlist_identifier"


class AllowlistIdentifierTypedDict(TypedDict):
    created_at: NotRequired[int]
    r"""Unix timestamp of creation

    """
    id: NotRequired[str]
    identifier: NotRequired[str]
    r"""An email address or a phone number.

    """
    identifier_type: NotRequired[IdentifierType]
    instance_id: NotRequired[str]
    invitation_id: NotRequired[str]
    object: NotRequired[AllowlistIdentifierObject]
    r"""String representing the object's type. Objects of the same type share the same value.

    """
    updated_at: NotRequired[int]
    r"""Unix timestamp of last update.

    """
    

class AllowlistIdentifier(BaseModel):
    created_at: Optional[int] = None
    r"""Unix timestamp of creation

    """
    id: Optional[str] = None
    identifier: Optional[str] = None
    r"""An email address or a phone number.

    """
    identifier_type: Optional[IdentifierType] = None
    instance_id: Optional[str] = None
    invitation_id: Optional[str] = None
    object: Optional[AllowlistIdentifierObject] = None
    r"""String representing the object's type. Objects of the same type share the same value.

    """
    updated_at: Optional[int] = None
    r"""Unix timestamp of last update.

    """
    
