"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
from .cnametarget import CNameTarget, CNameTargetTypedDict
from clerk_dev.types import BaseModel, Nullable
from enum import Enum
from pydantic import model_serializer
from typing import List, Optional, TypedDict
from typing_extensions import NotRequired


class DomainObject(str, Enum):
    DOMAIN = "domain"


class DomainTypedDict(TypedDict):
    development_origin: str
    frontend_api_url: str
    id: str
    is_satellite: bool
    name: str
    object: DomainObject
    accounts_portal_url: NotRequired[Nullable[str]]
    r"""Null for satellite domains.

    """
    cname_targets: NotRequired[Nullable[List[CNameTargetTypedDict]]]
    proxy_url: NotRequired[Nullable[str]]
    

class Domain(BaseModel):
    development_origin: str
    frontend_api_url: str
    id: str
    is_satellite: bool
    name: str
    object: DomainObject
    accounts_portal_url: Optional[Nullable[str]] = None
    r"""Null for satellite domains.

    """
    cname_targets: Optional[Nullable[List[CNameTarget]]] = None
    proxy_url: Optional[Nullable[str]] = None
    
    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["accounts_portal_url", "cname_targets", "proxy_url"]
        nullable_fields = ["accounts_portal_url", "cname_targets", "proxy_url"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)

            if val is not None:
                m[k] = val
            elif not k in optional_fields or (
                    k in optional_fields
                    and k in nullable_fields
                    and (self.__pydantic_fields_set__.intersection({n}) or k in null_default_fields) # pylint: disable=no-member
                ):
                m[k] = val

        return m
        
