"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
from .identificationlink import IdentificationLink, IdentificationLinkTypedDict
from clerk_dev.types import BaseModel, Nullable
from enum import Enum
from pydantic import model_serializer
from typing import List, Optional, TypedDict, Union
from typing_extensions import NotRequired


class PhoneNumberObject(str, Enum):
    r"""String representing the object's type. Objects of the same type share the same value.

    """
    PHONE_NUMBER = "phone_number"


class AdminVerificationPhoneNumberStatus(str, Enum):
    VERIFIED = "verified"


class AdminVerificationStrategy(str, Enum):
    ADMIN = "admin"
    FROM_OAUTH_DISCORD = "from_oauth_discord"


class VerificationAdminTypedDict(TypedDict):
    status: AdminVerificationPhoneNumberStatus
    strategy: AdminVerificationStrategy
    attempts: NotRequired[Nullable[int]]
    expire_at: NotRequired[Nullable[int]]
    

class VerificationAdmin(BaseModel):
    status: AdminVerificationPhoneNumberStatus
    strategy: AdminVerificationStrategy
    attempts: Optional[Nullable[int]] = None
    expire_at: Optional[Nullable[int]] = None
    
    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["attempts", "expire_at"]
        nullable_fields = ["attempts", "expire_at"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)

            if val is not None:
                m[k] = val
            elif not k in optional_fields or (
                    k in optional_fields
                    and k in nullable_fields
                    and (self.__pydantic_fields_set__.intersection({n}) or k in null_default_fields) # pylint: disable=no-member
                ):
                m[k] = val

        return m
        

class OTPVerificationStatus(str, Enum):
    UNVERIFIED = "unverified"
    VERIFIED = "verified"
    FAILED = "failed"
    EXPIRED = "expired"


class OTPVerificationStrategy(str, Enum):
    PHONE_CODE = "phone_code"
    EMAIL_CODE = "email_code"
    RESET_PASSWORD_EMAIL_CODE = "reset_password_email_code"
    FROM_OAUTH_DISCORD = "from_oauth_discord"


class VerificationOTPTypedDict(TypedDict):
    attempts: Nullable[int]
    expire_at: Nullable[int]
    status: OTPVerificationStatus
    strategy: OTPVerificationStrategy
    

class VerificationOTP(BaseModel):
    attempts: Nullable[int]
    expire_at: Nullable[int]
    status: OTPVerificationStatus
    strategy: OTPVerificationStrategy
    
    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = ["attempts", "expire_at"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)

            if val is not None:
                m[k] = val
            elif not k in optional_fields or (
                    k in optional_fields
                    and k in nullable_fields
                    and (self.__pydantic_fields_set__.intersection({n}) or k in null_default_fields) # pylint: disable=no-member
                ):
                m[k] = val

        return m
        

class PhoneNumberTypedDict(TypedDict):
    created_at: int
    r"""Unix timestamp of creation

    """
    linked_to: List[IdentificationLinkTypedDict]
    object: PhoneNumberObject
    r"""String representing the object's type. Objects of the same type share the same value.

    """
    phone_number: str
    reserved: bool
    updated_at: int
    r"""Unix timestamp of creation

    """
    verification: Nullable[PhoneNumberVerificationTypedDict]
    backup_codes: NotRequired[Nullable[List[str]]]
    default_second_factor: NotRequired[bool]
    id: NotRequired[str]
    reserved_for_second_factor: NotRequired[bool]
    

class PhoneNumber(BaseModel):
    created_at: int
    r"""Unix timestamp of creation

    """
    linked_to: List[IdentificationLink]
    object: PhoneNumberObject
    r"""String representing the object's type. Objects of the same type share the same value.

    """
    phone_number: str
    reserved: bool
    updated_at: int
    r"""Unix timestamp of creation

    """
    verification: Nullable[PhoneNumberVerification]
    backup_codes: Optional[Nullable[List[str]]] = None
    default_second_factor: Optional[bool] = None
    id: Optional[str] = None
    reserved_for_second_factor: Optional[bool] = None
    
    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["backup_codes", "default_second_factor", "id", "reserved_for_second_factor"]
        nullable_fields = ["verification", "backup_codes"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)

            if val is not None:
                m[k] = val
            elif not k in optional_fields or (
                    k in optional_fields
                    and k in nullable_fields
                    and (self.__pydantic_fields_set__.intersection({n}) or k in null_default_fields) # pylint: disable=no-member
                ):
                m[k] = val

        return m
        

PhoneNumberVerificationTypedDict = Union[VerificationOTPTypedDict, VerificationAdminTypedDict]


PhoneNumberVerification = Union[VerificationOTP, VerificationAdmin]

