"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
from clerk_dev.types import BaseModel, Nullable
from enum import Enum
from pydantic import model_serializer
from typing import List, Optional, TypedDict
from typing_extensions import NotRequired


class TemplateObject(str, Enum):
    r"""String representing the object's type. Objects of the same type share the same value.

    """
    TEMPLATE = "template"


class TemplateTypedDict(TypedDict):
    available_variables: NotRequired[List[str]]
    r"""list of variables that are available for use in the template body"""
    body: NotRequired[str]
    r"""the template body before variable interpolation"""
    can_delete: NotRequired[bool]
    r"""whether this template can be deleted"""
    can_disable: NotRequired[bool]
    r"""whether this template can be disabled, true only for notification SMS templates"""
    can_revert: NotRequired[bool]
    r"""whether this template can be reverted to the corresponding system default"""
    created_at: NotRequired[int]
    r"""Unix timestamp of creation.

    """
    delivered_by_clerk: NotRequired[bool]
    from_email_name: NotRequired[str]
    id: NotRequired[str]
    instance_id: NotRequired[Nullable[str]]
    r"""the id of the instance the template belongs to"""
    markup: NotRequired[str]
    r"""the editor markup used to generate the body of the template"""
    name: NotRequired[str]
    r"""user-friendly name of the template"""
    object: NotRequired[TemplateObject]
    r"""String representing the object's type. Objects of the same type share the same value.

    """
    position: NotRequired[int]
    r"""position with the listing of templates"""
    reply_to_email_name: NotRequired[str]
    required_variables: NotRequired[List[str]]
    r"""list of variables that must be contained in the template body"""
    resource_type: NotRequired[str]
    r"""whether this is a system (default) or user overridden) template"""
    slug: NotRequired[str]
    r"""machine-friendly name of the template"""
    subject: NotRequired[Nullable[str]]
    r"""email subject"""
    template_type: NotRequired[str]
    r"""whether this is an email or SMS template"""
    updated_at: NotRequired[int]
    r"""Unix timestamp of last update.

    """
    

class Template(BaseModel):
    available_variables: Optional[List[str]] = None
    r"""list of variables that are available for use in the template body"""
    body: Optional[str] = None
    r"""the template body before variable interpolation"""
    can_delete: Optional[bool] = None
    r"""whether this template can be deleted"""
    can_disable: Optional[bool] = None
    r"""whether this template can be disabled, true only for notification SMS templates"""
    can_revert: Optional[bool] = None
    r"""whether this template can be reverted to the corresponding system default"""
    created_at: Optional[int] = None
    r"""Unix timestamp of creation.

    """
    delivered_by_clerk: Optional[bool] = None
    from_email_name: Optional[str] = None
    id: Optional[str] = None
    instance_id: Optional[Nullable[str]] = None
    r"""the id of the instance the template belongs to"""
    markup: Optional[str] = None
    r"""the editor markup used to generate the body of the template"""
    name: Optional[str] = None
    r"""user-friendly name of the template"""
    object: Optional[TemplateObject] = None
    r"""String representing the object's type. Objects of the same type share the same value.

    """
    position: Optional[int] = None
    r"""position with the listing of templates"""
    reply_to_email_name: Optional[str] = None
    required_variables: Optional[List[str]] = None
    r"""list of variables that must be contained in the template body"""
    resource_type: Optional[str] = None
    r"""whether this is a system (default) or user overridden) template"""
    slug: Optional[str] = None
    r"""machine-friendly name of the template"""
    subject: Optional[Nullable[str]] = None
    r"""email subject"""
    template_type: Optional[str] = None
    r"""whether this is an email or SMS template"""
    updated_at: Optional[int] = None
    r"""Unix timestamp of last update.

    """
    
    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["available_variables", "body", "can_delete", "can_disable", "can_revert", "created_at", "delivered_by_clerk", "from_email_name", "id", "instance_id", "markup", "name", "object", "position", "reply_to_email_name", "required_variables", "resource_type", "slug", "subject", "template_type", "updated_at"]
        nullable_fields = ["instance_id", "subject"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)

            if val is not None:
                m[k] = val
            elif not k in optional_fields or (
                    k in optional_fields
                    and k in nullable_fields
                    and (self.__pydantic_fields_set__.intersection({n}) or k in null_default_fields) # pylint: disable=no-member
                ):
                m[k] = val

        return m
        
