"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
from clerk_dev.types import BaseModel, Nullable
from clerk_dev.utils import FieldMetadata, PathParamMetadata, RequestMetadata
from pydantic import model_serializer
from typing import Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class UpdateEmailAddressRequestBodyTypedDict(TypedDict):
    primary: NotRequired[Nullable[bool]]
    r"""Set this email address as the primary email address for the user."""
    verified: NotRequired[Nullable[bool]]
    r"""The email address will be marked as verified."""
    

class UpdateEmailAddressRequestBody(BaseModel):
    primary: Optional[Nullable[bool]] = None
    r"""Set this email address as the primary email address for the user."""
    verified: Optional[Nullable[bool]] = None
    r"""The email address will be marked as verified."""
    
    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["primary", "verified"]
        nullable_fields = ["primary", "verified"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)

            if val is not None:
                m[k] = val
            elif not k in optional_fields or (
                    k in optional_fields
                    and k in nullable_fields
                    and (self.__pydantic_fields_set__.intersection({n}) or k in null_default_fields) # pylint: disable=no-member
                ):
                m[k] = val

        return m
        

class UpdateEmailAddressRequestTypedDict(TypedDict):
    email_address_id: str
    r"""The ID of the email address to update"""
    request_body: NotRequired[UpdateEmailAddressRequestBodyTypedDict]
    

class UpdateEmailAddressRequest(BaseModel):
    email_address_id: Annotated[str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))]
    r"""The ID of the email address to update"""
    request_body: Annotated[Optional[UpdateEmailAddressRequestBody], FieldMetadata(request=RequestMetadata(media_type="application/json"))] = None
    
