"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
from clerk_dev.types import BaseModel, Nullable
from clerk_dev.utils import FieldMetadata, PathParamMetadata, RequestMetadata
from pydantic import model_serializer
from typing import Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class UpdateJWTTemplateClaimsTypedDict(TypedDict):
    r"""JWT template claims in JSON format"""
    
    

class UpdateJWTTemplateClaims(BaseModel):
    r"""JWT template claims in JSON format"""
    
    

class UpdateJWTTemplateRequestBodyTypedDict(TypedDict):
    allowed_clock_skew: NotRequired[Nullable[float]]
    r"""JWT token allowed clock skew"""
    claims: NotRequired[UpdateJWTTemplateClaimsTypedDict]
    r"""JWT template claims in JSON format"""
    custom_signing_key: NotRequired[bool]
    r"""Whether a custom signing key/algorithm is also provided for this template"""
    lifetime: NotRequired[Nullable[float]]
    r"""JWT token lifetime"""
    name: NotRequired[str]
    r"""JWT template name"""
    signing_algorithm: NotRequired[Nullable[str]]
    r"""The custom signing algorithm to use when minting JWTs"""
    signing_key: NotRequired[Nullable[str]]
    r"""The custom signing private key to use when minting JWTs"""
    

class UpdateJWTTemplateRequestBody(BaseModel):
    allowed_clock_skew: Optional[Nullable[float]] = None
    r"""JWT token allowed clock skew"""
    claims: Optional[UpdateJWTTemplateClaims] = None
    r"""JWT template claims in JSON format"""
    custom_signing_key: Optional[bool] = None
    r"""Whether a custom signing key/algorithm is also provided for this template"""
    lifetime: Optional[Nullable[float]] = None
    r"""JWT token lifetime"""
    name: Optional[str] = None
    r"""JWT template name"""
    signing_algorithm: Optional[Nullable[str]] = None
    r"""The custom signing algorithm to use when minting JWTs"""
    signing_key: Optional[Nullable[str]] = None
    r"""The custom signing private key to use when minting JWTs"""
    
    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["allowed_clock_skew", "claims", "custom_signing_key", "lifetime", "name", "signing_algorithm", "signing_key"]
        nullable_fields = ["allowed_clock_skew", "lifetime", "signing_algorithm", "signing_key"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)

            if val is not None:
                m[k] = val
            elif not k in optional_fields or (
                    k in optional_fields
                    and k in nullable_fields
                    and (self.__pydantic_fields_set__.intersection({n}) or k in null_default_fields) # pylint: disable=no-member
                ):
                m[k] = val

        return m
        

class UpdateJWTTemplateRequestTypedDict(TypedDict):
    template_id: str
    r"""The ID of the JWT template to update"""
    request_body: NotRequired[UpdateJWTTemplateRequestBodyTypedDict]
    

class UpdateJWTTemplateRequest(BaseModel):
    template_id: Annotated[str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))]
    r"""The ID of the JWT template to update"""
    request_body: Annotated[Optional[UpdateJWTTemplateRequestBody], FieldMetadata(request=RequestMetadata(media_type="application/json"))] = None
    
